﻿Public Class Form1

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        percorreDictionary()
    End Sub
    Public Sub percorreDictionary()
        ListBox1.Items.Clear()
        ' Cria um dictionary e inclui 8 chaves do tipo string
        Dim times As New Dictionary(Of String, Integer)
        times.Add("Palmeiras", 54)
        times.Add("Santos", 41)
        times.Add("Flamento", 49)
        times.Add("Atlético", 50)
        times.Add("Internacional", 41)
        times.Add("Goiás", 48)
        times.Add("Cruzeiro", 45)
        times.Add("Gremio", 46)

        ' Faz um Loop sobre as entradas do dicionário
        Dim par As KeyValuePair(Of String, Integer)
        For Each par In times
            ' Exibe a chave e os valores
            ListBox1.Items.Add(par.Key & "-" & par.Value)
        Next
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        UsandoContainsKey()
    End Sub
    Public Sub UsandoContainsKey()
        ListBox1.Items.Clear()
        'Declara um novo Dictionary  de chave 
        'do tipo string e valores integer
        Dim dictionary As New Dictionary(Of String, Integer)

        ' Inclui duas chaves : banana e maça
        ListBox1.Items.Add("Incluindo as chaves : banana(15) e maça(7)")
        dictionary.Add("banana", 7)
        dictionary.Add("maça", 15)

        ' Verficia se uma chave já existe
        If dictionary.ContainsKey("banana") Then
            ' Escreve um valor para a chave
            ListBox1.Items.Add("A chave banana já existe")
            Dim valor As Integer = dictionary.Item("banana")
            ListBox1.Items.Add("Valor = " & valor)
        End If

        ' Verifica se a chave ja existe
        If dictionary.ContainsKey("maça") Then
            ListBox1.Items.Add("A chave maça já existe")
            Dim valor As Integer = dictionary.Item("maça")
            ListBox1.Items.Add("Valor = " & valor)
        End If

        ' 
        If Not dictionary.ContainsKey("abacaxi") Then
            ListBox1.Items.Add("A chave abacaxi NÃO existe")
        End If


    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        ListBox1.Items.Clear()
        ' Cria 5 chaves e valores no dicionário
        Dim carros As New Dictionary(Of String, Integer)
        carros.Add("gol", 12)
        carros.Add("fiesta", 11)
        carros.Add("polo", 10)
        carros.Add("palio", -21)
        carros.Add("astra", -8)

        ' Põe a chave em uma lista de strings
        Dim lista As New List(Of String)(carros.Keys)

        ' Percorre a lista
        Dim str As String
        For Each str In lista
            ' Imprime a string e também o item 
            ListBox1.Items.Add(str & " - " & carros.Item(str))
        Next
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        ListBox1.Items.Clear()
        ' Cria um novo dicionario com 6 chaves
        Dim flores As New Dictionary(Of String, Integer)
        flores.Add("rosa", 20)
        flores.Add("cravo", 21)
        flores.Add("tulipa", 31)
        flores.Add("adália", 41)
        flores.Add("margarida", 61)
        flores.Add("orquídea", 91)

        ' Verifica se o valor 21 esta no dicionario
        If flores.ContainsValue(21) Then
            ListBox1.Items.Add("O valor 21 esta no dicionário.")
            ListBox1.Items.Add("O item é = " & flores.Item("tulipa"))
        End If

        ' Remove duas chaves: Remove
        flores.Remove("tulipa")
        flores.Remove("margarida")

        ListBox1.Items.Add("Removidas as chaves :  tulipa e margarida.")

        ' Faz um Loop sobre as entradas do dicionário
        Dim par As KeyValuePair(Of String, Integer)
        For Each par In flores
            ' Exibe a chave e os valores
            ListBox1.Items.Add("Valores e chaves existentes.")
            ListBox1.Items.Add(par.Key & "-" & par.Value)
        Next

    End Sub

    Private Sub dictionaryCount()
        ListBox1.Items.Clear()

        Dim legumes As New Dictionary(Of String, Integer)()
        legumes.Add("batata", 1)
        legumes.Add("cenoura", 4)
        legumes.Add("repolho", 6)
        legumes.Add("beterraba", 3)

        ' Copia as chaves
        Dim contador1 As Integer = legumes.Count

        ' Remove uma chave.
        legumes.Remove("cenoura")

        ' conta as chaves novamente
        Dim contador2 As Integer = legumes.Count

        ' Limpa o conteúdo do dicionário
        legumes.Clear()

        ' conta as chaves novamente
        Dim contador3 As Integer = legumes.Count

        ' Exibe os valores obtidos 
        ListBox1.Items.Add("contador1=" & contador1)
        ListBox1.Items.Add("contador2=" & contador2)
        ListBox1.Items.Add("contador3=" & contador3)
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        dictionaryCount()
    End Sub
    Private Sub dictionaryCopy()
        ListBox1.Items.Clear()

        Dim mamiferos As New Dictionary(Of String, Integer)()
        mamiferos.Add("cachoro", 1)
        mamiferos.Add("elefante", 9)
        mamiferos.Add("tigre", 10)

        ' Copia o Dicionário para o segundo objeto
        Dim copy As New Dictionary(Of String, Integer)(mamiferos)

        ' Altera o primeiro dicionário (Isso não causa alterações na copia)
        mamiferos.Add("tubarão", 4)

        ' Exibe o primeiro dicionário
        ListBox1.Items.Add("--- Dictionary 1 ---")
        For Each pair In mamiferos
            ListBox1.Items.Add(pair)
        Next

        ' Exibe o seguind dicionário
        ListBox1.Items.Add("--- Dictionary 2 ---")
        For Each pair In copy
            ListBox1.Items.Add(pair)
        Next
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        dictionaryCopy()
    End Sub
End Class
